#include <bits/stdc++.h>

using namespace std;
long int n;
char niz[300001];
long int brs=0,bri=0,bro=0;
long int brreci=0;
long int posebni[300001];
int main()
{
    scanf("%ld",&n);
    for(int i=1;i<n;i++)
    {
        long int x,y;
        scanf("%ld%ld",&x,&y);
        scanf("%c",niz[min(x,y)]);
    }
    niz[n]='\0';
    niz[0]='a';
    for(long int i=3;i<n;i+=3)
    {
        brs=0,bri=0,bro=0;
        char poslednji=1;
        for(long int j=1;j<n-i+1;j++)
        {
            if(niz[j]=='o') bro++;
            if(niz[j]=='s') brs++;
            if(niz[j]=='i') bri++;
            if(j==i){ if(bro>0&&bro==brs&&brs==bri&&posebni[1]!=bro) {posebni[1]=bro;brreci++;}} 
            else if(j>i)
            {
                if(niz[poslednji]=='o') bro--;
                if(niz[poslednji]=='s') brs--;
                if(niz[poslednji]=='i') bri--;
                if(bro>0&&bro==brs&&brs==bri&&posebni[j-i+1]!=bro) {posebni[j-i+1]=bro; brreci++;}
                poslednji++;
            }
            
        }
    }
    printf("%ld",brreci);
    return 0;
}